## umoci 0.5.0+ds

=== Makefile ===
# SPDX-License-Identifier: Apache-2.0
# umoci: Umoci Modifies Open Containers' Images
# Copyright (C) 2016-2025 SUSE LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Use bash, so that we can do process substitution.
SHELL := bash

# Go tools.
GO ?= go
GO_MD2MAN ?= go-md2man
GOOS ?= $(shell go env GOOS)
GOARCH ?= $(shell go env GOARCH)
export GO111MODULE=on

# Set up the ... lovely ... GOPATH hacks.
PROJECT := github.com/opencontainers/umoci
CMD := ${PROJECT}/cmd/umoci

# We use Docker because Go is just horrific to deal with.
UMOCI_IMAGE := umoci/ci:latest

# TODO: We should test umoci with all of the security options disabled so that
#       we can make sure umoci inside containers works fine (all of these
#       security options are necessary for the test code to run, not umoci
#       itself). The AppArmor/SELinux settings are needed because of the
#       mount-related tests, and the seccomp/systempaths settings are required
#       for the runc tests for rootless containers.
DOCKER_RUN = docker run --rm -v ${PWD}:/go/src/${PROJECT} \
                        --security-opt apparmor=unconfined \
                        --security-opt label=disable \
                        --security-opt seccomp=unconfined \
                        --security-opt systempaths=unconfined

# We only add the CodeCov environment (and ping codecov) if we're running in
# Travis, to avoid pinging third-party servers for local builds.
ifdef TRAVIS
$(shell echo "WARNING: This make invocation will fetch and run code from https://codecov.io/." >&2)
DOCKER_RUN += $(shell echo "+ Running https://codecov.io/env." >&2) \
              $(shell ./hack/ci-codecov.sh env)
endif

DOCKER_ROOTPRIV_RUN = $(DOCKER_RUN) --privileged --cap-add=SYS_ADMIN
DOCKER_ROOTLESS_RUN = $(DOCKER_RUN) -u 1000:1000 --cap-drop=all

# Output directory.
BUILD_DIR ?= .

# Release information.
GPG_KEYID ?=

# Version information.
VERSION := $(shell cat ./VERSION)
COMMIT_NO := $(shell git rev-parse HEAD 2> /dev/null || true)
COMMIT := $(if $(shell git status --porcelain --untracked-files=no),"${COMMIT_NO}-dirty","${COMMIT_NO}")

# Basic build flags.
BUILD_FLAGS ?=
BASE_FLAGS := ${BUILD_FLAGS} -tags "${BUILDTAGS}" -buildvcs=false
BASE_LDFLAGS := -s -w -X ${PROJECT}.gitCommit=${COMMIT} -X ${PROJECT}.version=${VERSION}

# Specific build flags for build type.
ifeq ($(GOOS), linux)
	DYN_BUILD_FLAGS := ${BASE_FLAGS} -buildmode=pie -ldflags "${BASE_LDFLAGS}"
	TEST_BUILD_FLAGS := ${BASE_FLAGS} -buildmode=pie -ldflags "${BASE_LDFLAGS} -X ${PROJECT}/pkg/testutils.binaryType=test"
else
	DYN_BUILD_FLAGS := ${BASE_FLAGS} -ldflags "${BASE_LDFLAGS}"
	TEST_BUILD_FLAGS := ${BASE_FLAGS} -ldflags "${BASE_LDFLAGS} -X ${PROJECT}/pkg/testutils.binaryType=test"
endif


STATIC_BUILD_FLAGS := ${BASE_FLAGS} -ldflags "${BASE_LDFLAGS} -extldflags '-static'"

# Installation directories.
DESTDIR ?=
PREFIX ?=/usr/local
BINDIR ?=$(PREFIX)/bin
MANDIR ?=$(PREFIX)/share/man

.DEFAULT: umoci

GO_SRC = $(shell find . -type f -name '*.go')

# NOTE: If you change these make sure you also update local-validate-build.

umoci: $(GO_SRC)
	GOOS=$(GOOS) GOARCH=$(GOARCH) $(GO) build ${DYN_BUILD_FLAGS} -o $(BUILD_DIR)/$@ ${CMD}

umoci.static: $(GO_SRC)
	env CGO_ENABLED=0 $(GO) build ${STATIC_BUILD_FLAGS} -o $(BUILD_DIR)/$@ ${CMD}

.PHONY: static
static: umoci.static

umoci.cover: $(GO_SRC)
	$(GO) test -c -cover -covermode=count -coverpkg=./... ${TEST_BUILD_FLAGS} -o $(BUILD_DIR)/$@ ${CMD}

.PHONY: release
release:
	hack/release.sh \
		-a 386 -a amd64 -a arm64 -a ppc64le -a riscv64 -a s390x \
		-v $(VERSION) -S "$(GPG_KEYID)"

.PHONY: install
install: umoci docs
	install -D -m0755 umoci $(DESTDIR)/$(BINDIR)/umoci
	-for man in $(MANPAGES); do \
		filename="$$(basename -- "$$man")"; \
		target="$(DESTDIR)/$(MANDIR)/man$${filename##*.}/$$filename"; \
		install -D -m0644 "$$man" "$$target"; \
		gzip -9f "$$target"; \
	 done

.PHONY: uninstall
uninstall:
	rm -f $(DESTDIR)/$(BINDIR)/umoci
	-rm -f $(DESTDIR)/$(MANDIR)/man*/umoci*

.PHONY: clean
clean:
	rm -f umoci umoci.static umoci-ci.tar umoci.cov*
	rm -f $(MANPAGES)

.PHONY: validate
validate: ci-image
	$(DOCKER_RUN) $(UMOCI_IMAGE) make local-validate

.PHONY: local-validate
local-validate: local-validate-go local-validate-reproducible local-validate-build

.PHONY: local-validate-keyring
local-validate-keyring:
	./hack/keyring_validate.sh

.PHONY: local-validate-go
local-validate-go:
	@type golangci-lint >/dev/null 2>/dev/null || (echo "ERROR: golanglint-ci not found." && false)
	golangci-lint run --max-issues-per-linter 0 --max-same-issues 0
	./hack/test-vendor.sh

# Make sure that our builds are reproducible even if you wait between them and
# the modified time of the files is different.
.PHONY: local-validate-reproducible
local-validate-reproducible:
	mkdir -p .tmp-validate
	make -B umoci && cp umoci .tmp-validate/umoci.a
	@echo sleep 10s
	@sleep 10s && touch $(GO_SRC)
	make -B umoci && cp umoci .tmp-validate/umoci.b
	diff -s .tmp-validate/umoci.{a,b}
	sha256sum .tmp-validate/umoci.{a,b}
	rm -r .tmp-validate/umoci.{a,b}

.PHONY: local-validate-build
local-validate-build:
	$(GO) build ${DYN_BUILD_FLAGS} -o /dev/null ${CMD}
	env CGO_ENABLED=0 $(GO) build ${STATIC_BUILD_FLAGS} -o /dev/null ${CMD}
	$(GO) test -run nothing ${DYN_BUILD_FLAGS} $(PROJECT)/...

MANPAGES_MD := $(wildcard doc/man/*.md)
MANPAGES    := $(MANPAGES_MD:%.md=%)

doc/man/%.1: doc/man/%.1.md
	$(GO_MD2MAN) -in $< -out $@

.PHONY: docs
docs: $(MANPAGES)

CI_DOCKER_IMAGE ?=$(shell sed -En 's/^FROM\s+(.*)/\1/p' Dockerfile)
TEST_DOCKER_IMAGE ?=$(shell sed -En 's/^ARG\s+TEST_DOCKER_IMAGE=(.*)/\1/p' Dockerfile)

ifndef COVERAGE
COVERAGE := $(notdir $(shell mktemp -u umoci.cov.XXXXXX))
endif
export COVERAGE

.PHONY: test-unit
test-unit: ci-image
	touch $(COVERAGE) && chmod a+rw $(COVERAGE)
	$(DOCKER_ROOTPRIV_RUN) -e COVERAGE $(UMOCI_IMAGE) make local-test-unit
	$(DOCKER_ROOTLESS_RUN) -e COVERAGE $(UMOCI_IMAGE) make local-test-unit

.PHONY: local-test-unit
local-test-unit:
	GO=$(GO) hack/test-unit.sh

.PHONY: test-integration
test-integration: ci-image
	touch $(COVERAGE) && chmod a+rw $(COVERAGE)
	$(DOCKER_ROOTPRIV_RUN) -e COVERAGE -e TESTS $(UMOCI_IMAGE) make local-test-integration
	$(DOCKER_ROOTLESS_RUN) -e COVERAGE -e TESTS $(UMOCI_IMAGE) make local-test-integration

.PHONY: local-test-integration
local-test-integration: umoci.cover
	TESTS="${TESTS}" hack/test-integration.sh

.PHONY: shell
shell: ci-image
	$(DOCKER_RUN) -it $(UMOCI_IMAGE) bash

.PHONY: root-shell
root-shell: ci-image
	$(DOCKER_ROOTPRIV_RUN) -it $(UMOCI_IMAGE) bash

.PHONY: rootless-shell
rootless-shell: ci-image
	$(DOCKER_ROOTLESS_RUN) -it $(UMOCI_IMAGE) bash

CACHE := .cache
CACHE_IMAGE := $(CACHE)/ci-image.tar.zst

.PHONY: ci-image
ci-image:
	docker pull $(CI_DOCKER_IMAGE)
	! [ -f "$(CACHE_IMAGE)" ] || unzstd < "$(CACHE_IMAGE)" | docker load
	DOCKER_BUILDKIT=1 docker build -t $(UMOCI_IMAGE) \
	                               --progress plain \
	                               --cache-from $(UMOCI_IMAGE) \
	                               --build-arg TEST_DOCKER_IMAGE=$(TEST_DOCKER_IMAGE) \
	                               --build-arg BUILDKIT_INLINE_CACHE=1 .

.PHONY: ci-cache
ci-cache: ci-image
	rm -rf $(CACHE) && mkdir -p $(CACHE)
	docker save $(UMOCI_IMAGE) | zstd > $(CACHE_IMAGE)

.PHONY: ci-validate
ci-validate: umoci umoci.static
	make docs local-validate

.PHONY: ci-unit
ci-unit: umoci.cover
	make test-unit

.PHONY: ci-integration
ci-integration: umoci.cover
	make test-integration

.PHONY: ci
ci:
	@echo "NOTE: This is not identical to the upstream CI, but the tests are the same."
	make ci-validate ci-unit ci-integration
	hack/ci-coverage.sh $(COVERAGE)

=== debian/changelog ===
umoci (0.5.0+ds-2) unstable; urgency=medium

  * Team upload
  * Fix Breaks versions

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 14 Aug 2025 12:39:35 +0000

umoci (0.5.0+ds-1) unstable; urgency=medium

  * Team upload
  * Upload changes from experimental to unstable
  * Add Breaks for affected packages

 -- Mathias Gibbens <gibmat@debian.org>  Mon, 11 Aug 2025 12:56:15 +0000

umoci (0.5.0+ds-1~exp2) experimental; urgency=medium

  * Team upload
  * Add patch to skip some tests that fail on the buildds

 -- Mathias Gibbens <gibmat@debian.org>  Tue, 03 Jun 2025 23:41:52 +0000

umoci (0.5.0+ds-1~exp1) experimental; urgency=medium

  * Team upload

  [ Mathias Gibbens ]
  * New upstream release:
    - Drop two patches applied upstream
    - Rebase remaining two patches
  * d/control:
    - Update Standards-Version to 4.7.2 (no changes needed)
    - Update Build-Depends and Depends
    - Add Static-Built-Using
  * Update d/copyright

  [ Nilesh Patra ]
  * Relax B-D condition on image-spec

 -- Mathias Gibbens <gibmat@debian.org>  Tue, 03 Jun 2025 01:18:54 +0000

umoci (0.4.7+ds-4) unstable; urgency=medium

  * Team upload.
  * Fix building with golang-github-opencontainers-image-spec-dev (>= 1.1.0~rc4)

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 20 Sep 2023 08:27:23 -0400

=== debian/control ===
Source: umoci
Section: devel
Priority: optional
Standards-Version: 4.7.2
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               go-md2man,
               golang-any (>= 2:1.23~),
               golang-github-apex-log-dev,
               golang-github-blang-semver-dev,
               golang-github-cyphar-filepath-securejoin-dev,
               golang-github-docker-go-units-dev,
               golang-github-klauspost-compress-dev,
               golang-github-klauspost-pgzip-dev,
               golang-github-moby-sys-dev,
               golang-github-mohae-deepcopy-dev,
               golang-github-opencontainers-go-digest-dev,
               golang-github-opencontainers-image-spec-dev (>= 1.1.0~rc4~),
               golang-github-opencontainers-specs-dev,
               golang-github-rootless-containers-proto-dev (>= 0.1.2~),
               golang-github-stretchr-testify-dev,
               golang-github-urfave-cli-dev,
               golang-github-vbatts-go-mtree-dev (>= 0.5.4+ds-1~),
               golang-golang-x-sys-dev,
               golang-google-protobuf-dev,
Homepage: https://umo.ci
Vcs-Browser: https://salsa.debian.org/go-team/packages/umoci
Vcs-Git: https://salsa.debian.org/go-team/packages/umoci.git
XS-Go-Import-Path: github.com/opencontainers/umoci
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-go

Package: umoci
Architecture: any
Built-Using: ${misc:Built-Using},
Static-Built-Using: ${misc:Static-Built-Using}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Open Container Images manipulation tool
 umoci creates and modifies Open Container images.
 See the official website (https://umo.ci/) for more accessible
 documentation about how to use umoci.
 .
 umoci intends to be a complete manipulation tool for OCI images
 (https://github.com/opencontainers/image-spec).  In particular, it should
 be seen as a more end-user-focused version of the oci-image-tools provided
 by the OCI (https://github.com/opencontainers/image-tools). The hope is
 that all of this tooling will eventually be merged with the upstream
 repository, so that it is always kept up-to-date by the Open Container
 Initiative community.
 .
 umoci provides tooling that can abstract all of the internals of the OCI
 specification into a single CLI interface.

Package: golang-github-opensuse-umoci-dev
Section: golang
Architecture: all
Multi-Arch: foreign
Depends: golang-github-apex-log-dev,
         golang-github-blang-semver-dev,
         golang-github-cyphar-filepath-securejoin-dev,
         golang-github-docker-go-units-dev,
         golang-github-klauspost-compress-dev,
         golang-github-klauspost-pgzip-dev,
         golang-github-moby-sys-dev,
         golang-github-mohae-deepcopy-dev,
         golang-github-opencontainers-go-digest-dev,
         golang-github-opencontainers-image-spec-dev (>= 1.1.0~rc4~),
         golang-github-opencontainers-specs-dev,
         golang-github-rootless-containers-proto-dev (>= 0.1.2~),
         golang-github-stretchr-testify-dev,
         golang-github-urfave-cli-dev,
         golang-github-vbatts-go-mtree-dev (>= 0.5.4+ds-1~),
         golang-golang-x-sys-dev,
         golang-google-protobuf-dev,
         ${misc:Depends},
Breaks: apptainer (<< 1.4.0-7),
        golang-github-mudler-docker-companion-dev (<< 0.4.5+git20250528.7d707b9+ds-1),
        golang-github-sylabs-singularity-dev (<= 4.1.5+ds4-1)
Description: umoci development files
 umoci creates and modifies Open Container images.
 See the official website (https://umo.ci/) for more accessible
 documentation about how to use umoci.
 .
 umoci intends to be a complete manipulation tool for OCI images
 (https://github.com/opencontainers/image-spec).  In particular, it should
 be seen as a more end-user-focused version of the oci-image-tools provided
 by the OCI (https://github.com/opencontainers/image-tools). The hope is
 that all of this tooling will eventually be merged with the upstream
 repository, so that it is always kept up-to-date by the Open Container
 Initiative community.
 .
 This package provides Golang sources for the umoci API.

=== debian/watch ===
version=4
opts="filenamemangle=s%.*/v?(\d\S*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
  repacksuffix=+ds,dversionmangle=auto" \
  https://github.com/opencontainers/umoci/tags .*/v?(\d\S*)\.tar\.gz

## umoci 0.6.0+ds

=== debian/changelog ===
umoci (0.6.0+ds-1) unstable; urgency=medium

  * Team upload
  * New upstream release:
    - Drop old image spec patch
    - Update/consolidate patch to skip certain tests
  * d/control:
    - Update Standards-Version to 4.7.3, drop Priority field
    - Update Build-Depends and Depends
    - Update Breaks
    - Drop redundant Rules-Requires-Root
  * Update r/dules to include needed VERSION file

 -- Mathias Gibbens <gibmat@debian.org>  Mon, 12 Jan 2026 20:24:34 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: umoci
 Section: devel
-Priority: optional
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Dmitry Smirnov <onlyjob@debian.org>,
 Build-Depends: debhelper-compat (= 13),
@@ -10,6 +9,7 @@
                golang-any (>= 2:1.23~),
                golang-github-apex-log-dev,
                golang-github-blang-semver-dev,
+               golang-github-containerd-platforms-dev,
                golang-github-cyphar-filepath-securejoin-dev,
                golang-github-docker-go-units-dev,
                golang-github-klauspost-compress-dev,
@@ -17,19 +17,18 @@
                golang-github-moby-sys-dev,
                golang-github-mohae-deepcopy-dev,
                golang-github-opencontainers-go-digest-dev,
-               golang-github-opencontainers-image-spec-dev (>= 1.1.0~rc4~),
-               golang-github-opencontainers-specs-dev,
+               golang-github-opencontainers-image-spec-dev (>= 1.1.1~),
+               golang-github-opencontainers-specs-dev (>= 1.2.1~),
                golang-github-rootless-containers-proto-dev (>= 0.1.2~),
                golang-github-stretchr-testify-dev,
                golang-github-urfave-cli-dev,
                golang-github-vbatts-go-mtree-dev (>= 0.5.4+ds-1~),
                golang-golang-x-sys-dev,
-               golang-google-protobuf-dev,
+               golang-google-protobuf-dev
 Homepage: https://umo.ci
 Vcs-Browser: https://salsa.debian.org/go-team/packages/umoci
 Vcs-Git: https://salsa.debian.org/go-team/packages/umoci.git
 XS-Go-Import-Path: github.com/opencontainers/umoci
-Rules-Requires-Root: no
 Testsuite: autopkgtest-pkg-go
 
 Package: umoci
@@ -60,6 +59,7 @@
 Multi-Arch: foreign
 Depends: golang-github-apex-log-dev,
          golang-github-blang-semver-dev,
+         golang-github-containerd-platforms-dev,
          golang-github-cyphar-filepath-securejoin-dev,
          golang-github-docker-go-units-dev,
          golang-github-klauspost-compress-dev,
@@ -67,8 +67,8 @@
          golang-github-moby-sys-dev,
          golang-github-mohae-deepcopy-dev,
          golang-github-opencontainers-go-digest-dev,
-         golang-github-opencontainers-image-spec-dev (>= 1.1.0~rc4~),
-         golang-github-opencontainers-specs-dev,
+         golang-github-opencontainers-image-spec-dev (>= 1.1.1~),
+         golang-github-opencontainers-specs-dev (>= 1.2.1~),
          golang-github-rootless-containers-proto-dev (>= 0.1.2~),
          golang-github-stretchr-testify-dev,
          golang-github-urfave-cli-dev,
@@ -76,7 +76,7 @@
          golang-golang-x-sys-dev,
          golang-google-protobuf-dev,
          ${misc:Depends},
-Breaks: apptainer (<< 1.4.0-7),
+Breaks: apptainer (<< 1.4.5-1),
         golang-github-mudler-docker-companion-dev (<< 0.4.5+git20250528.7d707b9+ds-1),
         golang-github-sylabs-singularity-dev (<= 4.1.5+ds4-1)
 Description: umoci development files

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DH_GOLANG_INSTALL_EXTRA := VERSION
GOLDFLAGS += -X github.com/opencontainers/umoci.version=$(DEB_VERSION)

%:
	dh $@ --buildsystem=golang --with=golang

execute_after_dh_auto_build:
	$(MAKE) docs

override_dh_auto_build:
	dh_auto_build -- -ldflags "$(GOLDFLAGS)"
